<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.4) on Wed Nov 20 09:59:45 CET 2019 -->
<title>nl.naturalis.oaipmh.api</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2019-11-20">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="nl.naturalis.oaipmh.api";
        }
    }
    catch(err) {
    }
//-->
var pathtoroot = "../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li class="navBarCell1Rev">Package</li>
<li>Class</li>
<li><a href="package-use.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<main role="main">
<div class="header">
<h1 title="Package" class="title">Package&nbsp;nl.naturalis.oaipmh.api</h1>
</div>
<div class="contentContainer">
<section role="region"><a id="package.description">
<!--   -->
</a>
<div class="block">Provides an API that OAI repositories can implement to have their data exposed by the Naturalis OAI-PMH server. Besides providing an API,
 this library comes with useful tools for OAI repository development, e.g.:
 <ul>
 <li>ready-made JAXB materializations of the ABCD, GGBN and OAI_DC schemas
 <li>utilities for checking the validaty of of an OAI-PMH request, for converting to and from OAIPMH-compliant date formats, etc.
 <li>database connection pooling
 </ul></div>
<dl>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Ayco Holleman</dd>
</dl>
</section>
<ul class="blockList">
<li class="blockList">
<table class="typeSummary">
<caption><span>Interface Summary</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Interface</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="OaiRepository.html" title="interface in nl.naturalis.oaipmh.api">OaiRepository</a></th>
<td class="colLast">
<div class="block">
 Specifies the capacities of an OAI repository.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="RepositoryGroup.html" title="interface in nl.naturalis.oaipmh.api">RepositoryGroup</a>&lt;T extends <a href="RepositoryConfig.html" title="class in nl.naturalis.oaipmh.api">RepositoryConfig</a>&gt;</th>
<td class="colLast">
<div class="block">Represents a group of OAI repositories that share a single configuration object and, most likely, one or more resources like a database
 connection.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="ResumptionTokenGenerator.html" title="interface in nl.naturalis.oaipmh.api">ResumptionTokenGenerator</a></th>
<td class="colLast">
<div class="block">Interface defining the capacity to generate a resumption token from the information in an <a href="OaiRequest.html" title="class in nl.naturalis.oaipmh.api"><code>OaiRequest</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="ResumptionTokenParser.html" title="interface in nl.naturalis.oaipmh.api">ResumptionTokenParser</a></th>
<td class="colLast">
<div class="block">Interface defining the capacity to decompose a resumption token into its constitutent parts.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="StandAloneRepository.html" title="interface in nl.naturalis.oaipmh.api">StandAloneRepository</a>&lt;T extends <a href="RepositoryConfig.html" title="class in nl.naturalis.oaipmh.api">RepositoryConfig</a>&gt;</th>
<td class="colLast">
<div class="block">An extension of <a href="OaiRepository.html" title="interface in nl.naturalis.oaipmh.api"><code>OaiRepository</code></a> that specifies the extra capacities an OAI repository needs to have to be plugged directly into the
 OAI-PMH framework, rather than as part of a <a href="RepositoryGroup.html" title="interface in nl.naturalis.oaipmh.api"><code>RepositoryGroup</code></a>.</div>
</td>
</tr>
</tbody>
</table>
</li>
<li class="blockList">
<table class="typeSummary">
<caption><span>Class Summary</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Class</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="AbstractOaiRepository.html" title="class in nl.naturalis.oaipmh.api">AbstractOaiRepository</a></th>
<td class="colLast">
<div class="block">Can be used as an abstract base class for OAI repositories.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="ArgumentValidator.html" title="class in nl.naturalis.oaipmh.api">ArgumentValidator</a></th>
<td class="colLast">
<div class="block">Abstract base class for classes that check the validity of the <a href="Argument.html" title="enum in nl.naturalis.oaipmh.api"><code>arguments</code></a> passed along with a <a href="../../../../org/openarchives/oai/_2/VerbType.html" title="enum in org.openarchives.oai._2"><code>verb</code></a> (like
 ListRecords).</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="ArgumentValidatorFactory.html" title="class in nl.naturalis.oaipmh.api">ArgumentValidatorFactory</a></th>
<td class="colLast">
<div class="block">Creates <a href="ArgumentValidator.html" title="class in nl.naturalis.oaipmh.api"><code>ArgumentValidator</code></a> instances.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="BadArgumentError.html" title="class in nl.naturalis.oaipmh.api">BadArgumentError</a></th>
<td class="colLast">
<div class="block">Convenience class narrowing the JAXB <code>OAIPMHerrorType</code> class to one for BadArgument errors.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="BadResumptionTokenError.html" title="class in nl.naturalis.oaipmh.api">BadResumptionTokenError</a></th>
<td class="colLast">
<div class="block">Convenience class narrowing the JAXB <code>OAIPMHerrorType</code> class to one for
 BadResumptionToken errors.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="BadVerbError.html" title="class in nl.naturalis.oaipmh.api">BadVerbError</a></th>
<td class="colLast">
<div class="block">Convenience class narrowing the JAXB <code>OAIPMHerrorType</code> class to one for
 BadVerb errors.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="CannotDisseminateFormatError.html" title="class in nl.naturalis.oaipmh.api">CannotDisseminateFormatError</a></th>
<td class="colLast">
<div class="block">Convenience class narrowing the JAXB <code>OAIPMHerrorType</code> class to one for CannotDisseminateFormat errors.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="DbRepositoryConfig.html" title="class in nl.naturalis.oaipmh.api">DbRepositoryConfig</a></th>
<td class="colLast">
<div class="block">A Configuration object for OAI repositories that use a database for data storage.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="DbRepositoryConfig.DatabaseConfig.html" title="class in nl.naturalis.oaipmh.api">DbRepositoryConfig.DatabaseConfig</a></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="IdDoesNotExistError.html" title="class in nl.naturalis.oaipmh.api">IdDoesNotExistError</a></th>
<td class="colLast">
<div class="block">Convenience class narrowing the JAXB <code>OAIPMHerrorType</code> class to one for
 IdDoesNotExist errors.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="ListRecordsArgumentChecker.html" title="class in nl.naturalis.oaipmh.api">ListRecordsArgumentChecker</a></th>
<td class="colLast">
<div class="block">An <a href="ArgumentValidator.html" title="class in nl.naturalis.oaipmh.api"><code>ArgumentValidator</code></a> for the <a href="../../../../org/openarchives/oai/_2/VerbType.html#LIST_RECORDS"><code>LIST_RECORDS</code></a> protocol request.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="NoRecordsMatchError.html" title="class in nl.naturalis.oaipmh.api">NoRecordsMatchError</a></th>
<td class="colLast">
<div class="block">Convenience class narrowing the JAXB <code>OAIPMHerrorType</code> class to one for
 NoRecordsMatch errors.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="NoSetHierarchyError.html" title="class in nl.naturalis.oaipmh.api">NoSetHierarchyError</a></th>
<td class="colLast">
<div class="block">Convenience class narrowing the JAXB <code>OAIPMHerrorType</code> class to one for
 NoSetHierarchy errors.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="OaiRequest.html" title="class in nl.naturalis.oaipmh.api">OaiRequest</a></th>
<td class="colLast">
<div class="block">Java bean modeling an OAI-PMH request.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="RepositoryConfig.html" title="class in nl.naturalis.oaipmh.api">RepositoryConfig</a></th>
<td class="colLast">
<div class="block">Java bean modeling the configuration for either a single OAI repository or a repository group.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="ResumptionToken.html" title="class in nl.naturalis.oaipmh.api">ResumptionToken</a></th>
<td class="colLast">
<div class="block">Default implementation of <a href="ResumptionTokenParser.html" title="interface in nl.naturalis.oaipmh.api"><code>ResumptionTokenParser</code></a> and <a href="ResumptionTokenGenerator.html" title="interface in nl.naturalis.oaipmh.api"><code>ResumptionTokenGenerator</code></a>.</div>
</td>
</tr>
</tbody>
</table>
</li>
<li class="blockList">
<table class="typeSummary">
<caption><span>Enum Summary</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Enum</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="Argument.html" title="enum in nl.naturalis.oaipmh.api">Argument</a></th>
<td class="colLast">
<div class="block">Symbolic constants for the seven URL query parameters allowed in a OAI-PMH request.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="DatabaseType.html" title="enum in nl.naturalis.oaipmh.api">DatabaseType</a></th>
<td class="colLast">
<div class="block">Symbolic constants for various databases.</div>
</td>
</tr>
</tbody>
</table>
</li>
<li class="blockList">
<table class="typeSummary">
<caption><span>Exception Summary</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Exception</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="BadResumptionTokenException.html" title="class in nl.naturalis.oaipmh.api">BadResumptionTokenException</a></th>
<td class="colLast">
<div class="block">Thrown when a resumption token cannot be decomposed into its constituent
 parts.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="OaiException.html" title="class in nl.naturalis.oaipmh.api">OaiException</a></th>
<td class="colLast">
<div class="block">An <code>OaiException</code> is thrown in response to an error condition explicitly mentioned by the OAI-PMH specification.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="OaiRuntimeException.html" title="class in nl.naturalis.oaipmh.api">OaiRuntimeException</a></th>
<td class="colLast">
<div class="block">RuntimeException subclass that can be thrown by implementations when processing OAI-PMH requests.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="RepositoryException.html" title="class in nl.naturalis.oaipmh.api">RepositoryException</a></th>
<td class="colLast">
<div class="block">Base class for all checked exceptions in this library except <a href="OaiException.html" title="class in nl.naturalis.oaipmh.api"><code>OaiException</code></a> and <code>ApplicationInitializationException</code>.</div>
</td>
</tr>
<tr class="altColor">
<th class="colFirst" scope="row"><a href="RepositoryInitializationException.html" title="class in nl.naturalis.oaipmh.api">RepositoryInitializationException</a></th>
<td class="colLast">
<div class="block">Thrown upon failure in the initialization phase of an <a href="StandAloneRepository.html" title="interface in nl.naturalis.oaipmh.api"><code>OAI repository</code></a> or <a href="RepositoryGroup.html" title="interface in nl.naturalis.oaipmh.api"><code>repository
 group</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colFirst" scope="row"><a href="XsdNotFoundException.html" title="class in nl.naturalis.oaipmh.api">XsdNotFoundException</a></th>
<td class="colLast">
<div class="block">Thrown by <code>StandAloneRepository#getXSDForMetadataPrefix(java.io.OutputStream, String)</code> if the requested XSD cannot be served.</div>
</td>
</tr>
</tbody>
</table>
</li>
</ul>
</div>
</main>
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../index.html">Overview</a></li>
<li class="navBarCell1Rev">Package</li>
<li>Class</li>
<li><a href="package-use.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
